from copo import Copo

class Calle:
    def __init__(self, horizontal: bool, starting_x: int, starting_y: int,
                 length: int, temperature: int):
        """ Crea un objeto Calle """
        self.horizontal = horizontal
        self.x_inicial = starting_x
        self.y_inicial = starting_y
        self.longitud = length
        self.temperatura = temperature
        self.copos = []

    def __str__(self):
        res = "Calle "
        if self.horizontal:
            end = "(" + str(self.x_inicial + self.longitud) + "," + str(
                self.y_inicial) + ")"
            res += "H-"+str(self.y_inicial)
        else:
            end = "(" + str(self.x_inicial) + "," + str(self.y_inicial +
                                                        self.longitud) + ")"
            res += "V-"+str(self.x_inicial)
        res += ", va de (" + str(self.x_inicial) + "," + str(
            self.y_inicial) + ") a " + end + ". Temperatura: " + str(
            self.temperatura)
        return res

    def necesita_limpieza(self)-> bool:
        """ Comprueba si hay que limpiar la calle"""
        if self.temperatura >= 2:
            return False
        else:
            # Miramos si hay dos copos de nieve en alguna de las coordenadas
            for index1 in range(len(self.copos)):
                for index2 in range(index1 + 1, len(self.copos)):
                    if (self.copos[index1].x == self.copos[index2].x
                            and self.copos[index1].y ==
                            self.copos[index2].y):
                        return True
            # Si llegamos aquí, no hay dos copos de nieve en el mismo sitio
            return False